# zeroboard4-php8
***기존 저장소 github 계정을 분실하여서 본 계정의 저장소에서 이어서 배포합니다.***   

제로보드 4.1의 최종 버전인 pl8 UTF-8(zb4pl8.utf8.zip)에 php 8.x 호환 작업과 여러가지 유용한 패치를 하였습니다.   

본 프로젝트는 제로보드 4.1의 외관 및 기능적인 부분은 원형 그대로 보존 하면서도, 모든 기능이 php 8.x 이상에서 정상 작동되며 약간의 보안적인 이득을 얻는 것을 목표로 하고 있습니다.   
***그러나, 패치되지 못한 보안 취약점이 존재할 수 있기 때문에 반드시 기존 사이트 유지보수용으로만 사용하여야 합니다.***   

## 주요 패치내용
- [x] php 8.x 환경에서의 정상 작동 보장
- [x] old_password() 대응 및 MySQL 8 환경 등에서 password() SQL 함수 사용이 불가한 경우에 대한 대응
- [x] 게시판 스킨을 php 8.x 이상 환경에서 사용 가능하도록 자동으로 패치하는 기능을 추가
- [x] 기초적인 보안 취약점 패치
- [x] [CloudFlare CDN 관련 문제점 패치](https://gist.github.com/kijin/25be59ac4b0d7c5ef722)
- [x] 관리자 페이지의 "DB 상태 보기"메뉴 클릭 시 비밀번호 해시 길이를 41자까지 사용 할 수 있도록 자동 패치
- [x] YouTube iframe 태그를 사용 할 수 있도록 패치
- [x] php 8.x 이상에서 나타나는 정의되지 않은 변수 관련 Warning 대부분 제거
- [x] 원본보다 최소 2.5배 이상 빠른 속도
- [x] 이외에 브라우저 환경에 따라 작동하지 않는 기능 몇가지 패치

## 변경된 기능
CHANGELOG.md 파일을 참조하십시오.

## 테스트 환경
* UTF-8 캐릭터셋 서버 환경
* Apache 2.4.58
* nginx 1.20.1
* php 8.2.12 (>= 5.0.0)
* MariaDB 10.4.32

## 유의사항
본 프로젝트를 이용해서 일어나는 일에 대한 책임은 전적으로 이용자 본인에게 있습니다.   
  
게시판 관리 화면에서 정리(오류복구) 기능을 실행하는 경우 게시판 스킨을 php 8 환경에서 사용 가능하도록 패치를 시도합니다.  
해당 기능으로도 정상 동작이 불가한 스킨은 직접 패치하셔야 합니다.
